# an attempt at a generic menu loader that needs only the lang file ...
module JcB
  # the menu ruby loads the logic ruby on demand...
  module SineCircle
    extend self

    # add rescue for pre Ruby 2
    path = __dir__ rescue File.dirname(__FILE__)

    # to handle the new file formats for toolbar images...
    ext = '.png'
    ver = Sketchup.version.to_i
    if ver >= 16
      osx = Sketchup.platform == :platform_osx
      ext = osx ? '.pdf' : '.svg'
    end

    title =  TRANSL8["#{TITLE}"]
    # create toolbar
    tb = UI::Toolbar.new(title)
    # menu item
    menu = UI.menu('Plugins', title)

    # add a cmd for menu, toolbar or shortcut item...
    cmd = UI::Command.new(title) do
      # use load for testing with .rb and require for production without...
      load File.join(path, "#{NAME}_logic.rb")
      # require File.join(path, "#{NAME}_logic")
      # this method becomes available on load as it's defined under the same namespace...
      user_input
    end

    cmd.tooltip = cmd.status_bar_text =  TRANSL8['Create sine waves on cylinders'] + '...'

    cmd.large_icon = cmd.small_icon = File.join(path, 'Resources', 'images', "#{NAME}#{ext}")

    unless file_loaded? "#{NAME}_menu.rb"
      menu.add_item(cmd)
      tb.add_item(cmd)
      # showing the toolbar
      tb.get_last_state == -1 ? tb.show : tb.restore
      file_loaded("#{NAME}_menu.rb")
    end # unless
  end # module SineCircle
end # module JcB

